'************************************************************************************* 
' 
' Peter Mather
' 
' 1.2 
' 2015-18-1 
'                                                                                   ' V1.0
' Graphics library with drivers for ST7781 TFT 2.4" display
' NB this display controller reports an ID of 7783
'
' drawing primitives assume a graphics display where top left is point 0, 0
'
' set screen orientation: sub T18.setrot(x) ;T18_normal=normal, T18_inverse=invert, T18_rt_right=rotate right, T18_rt_left=rotate left
' draw circle: sub T18.dcirc(x0, y0, r, colour) ;x, y coordinates of centre, radius, colour
' draw filled circle: sub T18.fcirc(x0, y0, r, colour) ;x, y coordinates of centre, radius, colour
' draw triangle:  sub T18.dtri(x0, y0, x1, y1, 	x2, y2, colour) ;three coordinate pairs, colour
' draw filled triangle sub T18.ftri (x0, y0, x1, y1, x2, y2, colour) ;three coordinate pairs, colour
' print string: sub T18.pstring(xx0, yy0, text$, sz, orientation, forecolour, backcolour) ;x, y coordinates of top left of first character, text string, size, character orientation,  foreground colour,  background colour
' print 8x5 bitmap: sub I9341.pbitmap(xx0, yy0, char, sz, orientation, forecolour, backcolour) ;x, y coordinates of top left of first character, bitmap, size, character orientation,  foreground colour,  background colour
' draw line: sub T18.dline(xx0, yy0, xx1, yy1, colour) ;x, y of start line, x, y of end line, colour
' draw rectangle: sub T18.drect(x, y, w, h, colour) ;x, y coordinate of top left, width, height, colour
' draw filled rectangle: sub T18.frect(x, y, w, h, colour) ;x, y coordinate of top left, width, height, colour
' draw rounded rectangle: sub T18.drndrect(x, y, w, h, r, colour) ;x, y coordinates of top left, width, height, radius of corner, colour
' draw filled rounded rectangle: sub T18.frndrect(x, y, w, h, r, colour) ;x, y coordinates of top left, width, height, radius of corner, colour
'
'
option explicit
option default NONE
cpu 48
  T24_initialise
do
  T24_test
loop
end
'
' ST7783 specific routines
'
sub T24.initdisplay
'Global "Constants"
  dim integer T24_CS=2 'a0
  dim integer T24_CD=3 'a1
  dim integer T24_WR=9 'a2
  dim integer T24_RD=10 'a3
  dim integer T24_RESET= 14 'b5
  dim integer T24_D0=4' b0
  dim integer T24_D1=5' b1
  dim integer T24_D2=6' b2
  dim integer T24_D3=7' b3
  dim integer T24_D4=23' b12
  dim integer T24_D5=24' b13
  dim integer T24_D6=25' b14
  dim integer T24_D7=26' b15
  dim integer BLACK = &H0000 ' Color definitions: 16 bit (RGB565) colour palette so these are just examples
  dim integer BLUE  = &H001F
  dim integer RED   = &HF800
  dim integer GREEN = &H07E0
  dim integer CYAN  = &H07FF
  dim integer MAGENTA=&HF81F
  dim integer YELLOW= &HFFE0 
  dim integer WHITE = &HFFFF
  dim integer T24.pix=0
  dim integer T24.ffr=1
  dim integer T24.filltri=2
  dim integer T24.drawline=3
  dim integer T24.writecommand=4
  dim integer T24.writedata=5
  dim integer T24.fpstring=7
  dim integer T24.fcirch=8
  dim integer T24.dcirch=9
  dim integer T24_normal=0
  dim integer T24_inverse=1
  dim integer T24_rt_right=2
  dim integer T24_rt_left=3
  ' Global variables
  dim integer T24_AddrOfFont,   T24_params(6) ' Global variables
  DIM integer T24_wi=0,T24_ht=1,T24_rot=2,T24_nr=3,T24_X=4,T24_Y=5,T24_seed=6
  T24_AddrOfFont=PEEK(CFunAddr FONT)  
  local integer i
  T24_params(T24_wi)=240
  T24_params(T24_ht)=320
  pin(T24_CS)=1
  setpin T24_CS, DOUT
  pin(T24_CD)=1
  setpin T24_CD, DOUT
  pin(T24_WR)=1
  setpin T24_WR, DOUT
  pin(T24_RD)=1
  setpin T24_RD, DOUT
  pin(T24_RESET)=1
  setpin T24_RESET, DOUT'  Reset the display
  T24.setwrite
  pin(T24_RESET)=0
  pause 100
  pin(T24_RESET)=1
  pause 100
  T24.wreg(&HFF, 1)
  T24.wreg(1, &H100)
  T24.wreg(2, &H700)
  T24.wreg(3, &H1030)
  T24.wreg(8, &H302)
  T24.wreg(9, 0)
  T24.wreg(&H10, 0)
  T24.wreg(&H11, 7)
  T24.wreg(&H12, 0)
  T24.wreg(&H13, 0)
  pause 20
  T24.wreg(&H10, &H14B0)
  pause 10
  T24.wreg(&H11, 7)
  pause 10
  T24.wreg(&H12, &H8E)
  T24.wreg(&H13, &HC00)
  T24.wreg(&H29, &H15)
  pause 10
  T24.wreg(&H30, 0)
  T24.wreg(&H31, &H107)
  T24.wreg(&H32, 0)
  T24.wreg(&H35, &H203)
  T24.wreg(&H36, &H402)
  T24.wreg(&H37, 0)
  T24.wreg(&H38, &H207)
  T24.wreg(&H39, 0)
  T24.wreg(&H3C, &H203)
  T24.wreg(&H3D, &H403)
  T24.wreg(&H50, 0)
  T24.wreg(&H51, &HEF)
  T24.wreg(&H52, 0)
  T24.wreg(&H53, &H13F)
  T24.wreg(&H60, &HA700)
  T24.wreg(&H61, 1)
  T24.wreg(&H90, &H29)
  T24.wreg(7, &H133)
  pause 50
'  i=T24draw(T24.writecommand, &H22)
  t24.setrot(T24_normal)
end sub
'
sub T24.wreg(register as integer, databyte as integer)
  local integer i
  i=T24draw(T24.writecommand, register)
  i=T24draw(T24.writedata, databyte)
end sub
'
function T24.rreg(register as integer) as integer
  local integer i
  i=T24draw(T24.writecommand, register)
  T24.setread
  T24.rreg= T24.readdata()
  T24.setwrite
end function
'
sub T24.fillscreen(scol as integer)
  local integer i=T24_params(T24_rot)
  t24_params(T24_rot)=0
  local integer j=T24draw(T24.ffr,scol, 0,0,T24_params(T24_wi),T24_params(T24_ht), T24_params())
  t24_params(T24_rot)=i
end sub
'
end sub
'
function  T24.readdata() as integer
  local integer i 
  pin(T24_CS)=0
  PIN(T24_CD)=1
  pin(T24_WR)=1
  pin(T24_RD)=0
  pause 1
  i=(port(4, 4, 23, 4))<<8
  pin(T24_RD)=1
  pin(T24_RD)=0
  pause 1
  i=i+port(4, 4, 23, 4)
  pin(T24_RD)=1
  pin(T24_CS)=1
  T24.readdata=i
end function
'
sub T24.setwrite
  setpin T24_CS, DOUT
  setpin T24_CD, DOUT
  setpin T24_WR, DOUT
  setpin T24_RD, DOUT
  setpin T24_RESET, DOUT'  Reset the display
  setpin T24_D0, dout
  setpin T24_D1, dout
  setpin T24_D2, dout
  setpin T24_D3, dout
  setpin T24_D4, dout
  setpin T24_D5, dout
  setpin T24_D6, dout
  setpin T24_D7, dout
end sub
'
sub T24.setread
  setpin T24_D0, din
  setpin T24_D1, din
  setpin T24_D2, din
  setpin T24_D3, din
  setpin T24_D4, din
  setpin T24_D5, din
  setpin T24_D6, din
  setpin T24_D7, din
end sub
'
' Generic drawing routines
'
sub T24.dcirc(x0 as integer, y0 as integer, r as integer, colour as integer) 'x, y coordinates of centre, radius
  local integer i=T24draw(T24.dcirch, colour,x0,y0,r,31,T24_params())

end sub
 '
sub T24.dtri(x0 as integer, y0 as integer, x1 as integer, y1 as integer, x2 as integer, y2 as integer, colour as integer) 'three coordinate pairs
  T24.dline(x0, y0, x1, y1, colour)
  T24.dline(x1, y1, x2, y2, colour)
  T24.dline(x2, y2, x0, y0, colour)
end sub
 '
sub T24.ftri (x0 as integer, y0 as integer, x1 as integer, y1 as integer, x2 as integer, y2 as integer, colour as integer) 'three coordinate pairs
  local integer i=T24draw(T24.filltri, x0,y0,x1,y1,x2,y2,colour,T24_params())
end sub
'
sub T24.pstring(xx0 as integer, yy0 as integer, text$, sz as integer, orientation as integer, fontcolour as integer, backgroundcolour as integer) 'x, y coordinates of top left of first character, text string, size, orientation
  local integer i=T24draw(T24.fpstring,T24_AddrOfFont,xx0,yy0,sz,orientation,fontcolour,backgroundcolour,T24_params(),text$)
end sub
'
sub T24.pbitmap(xx0 as integer, yy0 as integer, char as integer, sz as integer, orientation as integer, fontcolour as integer, backgroundcolour as integer) 'x, y coordinates of top left of first character, text string, size, orientation
  local integer i=T24draw(T24.fpstring,char,xx0,yy0,sz,orientation,fontcolour,backgroundcolour,T24_params(),"")
end sub
'
sub T24.dline(xx0 as integer, yy0 as integer, xx1 as integer, yy1 as integer, colour as integer) ' x, y of start line, x, y of end line
   local integer dp=T24draw(T24.drawline, colour, xx0, yy0, xx1, yy1,  T24_params())
end sub
'
sub T24.drect(x as integer, y as integer, w as integer, h as integer, rcolour as integer) 'x, y coordinate of top left, wi, ht
  local integer a, dp
  dp=T24draw(T24.ffr, rcolour, x, y, w, 1,  T24_params()) 
  a=y+h-1
  dp=T24draw(T24.ffr, rcolour, x, a, w, 1,  T24_params()) 
  dp=T24draw(T24.ffr, rcolour, x, y, 1, h,  T24_params()) 
  a=x+w-1
  dp=T24draw(T24.ffr, rcolour, a, y, 1, h,  T24_params()) 
end sub
'
sub T24.frect(x as integer, y as integer, w as integer, h as integer, rcolour as integer) 'x, y coordinate of top left, width, height
  local integer dp
  dp=T24draw(T24.ffr, rcolour, x, y, w, h,  T24_params()) 
end sub
'
FUNCTION T24.Getchar(char as integer) as integer
  local integer i=char<<3
  T24.Getchar=PEEK(WORD T24_AddrOfFont+i)+(PEEK(WORD T24_AddrOfFont+i+4)<<32) 
END FUNCTION
'
sub T24.fcirc(x0 as integer, y0 as integer, r as integer, ccolour as integer)  'x, y coordinates of centre, radius
  local integer dp
  dp=T24draw(T24.ffr, ccolour, x0, y0-r, 1, 2*r+1,  T24_params())
  dp=T24draw(T24.fcircH,x0, y0, r, 3, 0, ccolour, T24_params())
end sub
 '
sub T24.drndrect(x as integer, y as integer, w as integer, h as integer, r as integer, rcolour as integer) 'x, y coordinates of top left, width, height, radius of corner
  local integer dp
  dp=T24draw(T24.ffr, rcolour, x+r, y, w-2*r, 1,  T24_params()) 
  dp=T24draw(T24.ffr, rcolour, x+r, y+h-1, w-2*r, 1,  T24_params()) 
  dp=T24draw(T24.ffr, rcolour, x, y+r, 1, h-2*r,  T24_params()) 
  dp=T24draw(T24.ffr, rcolour, x+w-1, y+r, 1, h-2*r,  T24_params()) 
  dp=T24draw(T24.dcirch, rcolour, x+r, y+r, r, 1,T24_params())
  dp=T24draw(T24.dcirch,  rcolour, x+w-r-1, y+r, r, 2,T24_params())
  dp=T24draw(T24.dcirch,  rcolour, x+w-r-1, y+h-r-1, r, 4,T24_params())
  dp=T24draw(T24.dcirch,  rcolour, x+r, y+h-r-1, r, 8,T24_params())
end sub
'
sub T24.frndrect(x as integer, y as integer, w as integer, h as integer, r as integer, colour as integer) 'x, y coordinates of top left, width, height, radius of corner
  local integer dp
  dp=T24draw(T24.ffr, colour, x+r, y, w-2*r, h,  T24_params()) 
  dp=T24draw(T24.fcircH,x+w-r-1, y+r, r, 1, h-2*r-1, colour, T24_params())
  dp=T24draw(T24.fcircH,x+r, y+r, r, 2, h-2*r-1, colour, T24_params())
end sub
 '
sub T24.setrot(x%) 'sets screen rotation: 0=T24_normal, 1=invert, 2=rotate right, 3-rotate left
   T24_params(T24_rot)=(x% and 3)
end sub
'
'D:\Peter\MPLABXProjects\ST7781\dist\default\production\T24draw.bas

'
'T24draw  2015-01-18 13:18:11 CFuncGen Ver 1.0.21 by user=Peter
'
CFunction T24draw
'write
	000006C7
	3082ff00 308400ff 7c461a00 00041a00 3063f00f 24080001 3c07bf88 ace86034 
	10a00005 24070002 3c05bf88 aca76034 10000004 3c05bf88 3c05bf88 aca76038 
	3c05bf88 24070004 aca76038 24080008 aca86038 aca76034 8ca86130 31080ff0 
	aca86130 8ca86130 00481025 00463025 aca66130 3c02bf81 8c46f220 aca76038 
	8c46f220 aca76034 8ca66130 30c60ff0 aca66130 8ca66130 00862025 00831825 
	aca36130 8c42f220 aca76038 24020001 aca26038 03e00008 00000000 

'writeCommand
27bdffe8 
	afbf0014 24050001 0411FFCD 00000000 8fbf0014 03e00008 27bd0018 

'writeData
27bdffe8 
	afbf0014 00002821 0411FFC5 00000000 8fbf0014 03e00008 27bd0018 

'setpixel
27bdffe0 
	afbf001c afb10018 afb00014 00808021 00a08821 24040020 0411FFE8 00000000 
	02002021 0411FFED 00000000 24040021 0411FFE2 00000000 02202021 0411FFE7 
	00000000 24040022 0411FFDC 00000000 8fbf001c 8fb10018 8fb00014 03e00008 
	27bd0020 

'setpos
27bdffd8 afbf0024 afb30020 afb2001c afb10018 afb00014 00808021 
	00a08821 00c09821 00e09021 24040050 0411FFCA 00000000 02002021 0411FFCF 
	00000000 24040051 0411FFC4 00000000 02202021 0411FFC9 00000000 24040052 
	0411FFBE 00000000 02602021 0411FFC3 00000000 24040053 0411FFB8 00000000 
	02402021 0411FFBD 00000000 02002021 02602821 0411FFC1 00000000 8fbf0024 
	8fb30020 8fb2001c 8fb10018 8fb00014 03e00008 27bd0028 

'localfastfillrect
27bdffd0 afbf002c 
	afb50028 afb40024 afb30020 afb2001c afb10018 afb00014 8fab0040 8fad0048 
	8fae0050 8fa80058 8d090000 8d0c0008 8d080010 308aff00 308400ff 7d511a00 
	022a8825 00048200 3210f00f 15000014 02048025 00c9102a 0000a021 10400085 
	0000a821 24c5ffff 00ad2821 00a9182a 2522ffff 0043280a 016c102a 1040007d 
	2567ffff 00ee3821 00ec182a 2582ffff 0043280a 01601021 1000002d 00c01821 
	24040001 55040015 24040002 00062827 00a92821 0000a021 04a0006e 0000a821 
	000b3827 00ec3821 04e00069 24020001 004d6823 01a56821 29a30000 0003680b 
	01a01821 004e7023 01c77021 29c20000 0002700b 1000002b 01c01021 15040015 
	24040003 000b2827 00a92821 00a9182a 2522ffff 0043280a 00ae1823 24630001 
	28620000 0002180b 00cc102a 0000a021 10400050 0000a821 24c7ffff 00ed3821 
	00ec202a 14800002 00c01021 2587ffff 24040003 55040014 24a40001 0169102a 
	0000a021 10400043 0000a821 2565ffff 00ae2821 00a9102a 2529ffff 00063827 
	00ec3821 04e0003b 0122280a 00ed1023 24420001 04410003 01601821 01601821 
	00001021 24a40001 00832023 24f30001 02629823 72649802 00602021 00403021 
	0411FF60 00000000 3c02bf88 24030001 ac436034 24030002 ac436038 24030004 
	ac436038 24030008 ac436038 1260001a 2673ffff 24030004 3c04bf81 2406ffff 
	ac436034 8c456130 30a50ff0 ac456130 8c456130 02252825 ac456130 8c85f220 
	ac436038 8c85f220 ac436034 8c456130 30a50ff0 ac456130 8c456130 02052825 
	ac456130 8c92f220 ac436038 2673ffff 1666ffeb 00000000 24030001 3c02bf88 
	ac436038 0240a021 10000002 0012afc3 0000a821 02801021 02a01821 8fbf002c 
	8fb50028 8fb40024 8fb30020 8fb2001c 8fb10018 8fb00014 03e00008 27bd0030 

'localdrawPixel
	27bdffe8 afbf0014 afb00010 00808021 8fa20030 8c470000 8c430008 8c420010 
	24040001 14440006 8fa80028 00062027 00872021 00082827 1000000f 00a32821 
	24040002 54440005 24040003 00082027 00872021 10000008 00c02821 14440004 
	00062827 00a32821 10000003 01002021 01002821 00c02021 00851027 000217c2 
	0087382a 00a3182a 00e31824 00431824 00004021 10600008 00004821 0411FEE7 
	00000000 02002021 0411FEDC 00000000 24080001 00004821 01001021 01201821 
	8fbf0014 8fb00010 03e00008 27bd0018 

'swap
8c820000 8ca30000 ac830000 03e00008 
	aca20000 

'drawline
27bdffa8 afbf0054 afb70050 afb6004c afb50048 afb40044 afb30040 
	afb2003c afb10038 afb00034 0080a021 00a0a821 8fa40068 8fa20070 8fa30078 
	8fb30080 afa60020 afa40024 afa20028 afa3002c 0083882a 00642823 00831823 
	0071280a 00c2202a 00461823 00c21023 0064100b 0045882a 1220000a 8fa20028 
	27a40020 27a50024 0411FFD9 00000000 27a40028 27a5002c 0411FFD5 00000000 
	8fa20028 8fa30020 0043102a 1040000a 8fa30028 27a40020 27a50028 0411FFCC 
	00000000 27a40024 27a5002c 0411FFC8 00000000 8fa30028 8fa20020 8fa4002c 
	8fb20024 0244282a 10a00007 0062b023 00929023 001687c2 02168021 00108043 
	10000006 24170001 02449023 001687c2 02168021 00108043 2417ffff 0062182a 
	14600028 8fbf0054 1220000e 8fa30024 8fa70024 afa20010 000217c3 afa20014 
	afb30018 02802021 02a02821 00e03021 00073fc3 0411FF72 00000000 1000000c 
	02128023 afa30010 00031fc3 afa30014 afb30018 02802021 02a02821 00403021 
	00023fc3 0411FF66 00000000 02128023 06010006 8fa20020 8fa20024 00571021 
	afa20024 02168021 8fa20020 24420001 afa20020 8fa30028 0062182a 1060ffda 
	8fbf0054 8fb70050 8fb6004c 8fb50048 8fb40044 8fb30040 8fb2003c 8fb10038 
	8fb00034 03e00008 27bd0058 

'drawchar
27bdff68 afbf0094 afbe0090 afb7008c afb60088 
	afb50084 afb40080 afb3007c afb20078 afb10074 afb00070 afa600a0 afa700a4 
	8fa200b0 afa2005c 8fa300b8 afa30060 8fa200c0 afa20058 8fb400d0 8fa3005c 
	afa30048 8fa20060 afa2004c 8fb00058 8fa300c8 afa30050 afa40030 14600061 
	afa50034 00102823 afa50054 00101080 00501021 8fa5005c 00a21021 afa20044 
	24a20005 afa20040 27b60030 27a30036 afa30038 00009021 24170001 241e0008 
	02008821 10000049 0280a821 92c20000 02021007 30420001 1040001c 00000000 
	5637000c afb30010 afb40010 afb20014 afb50018 8fa400a0 8fa500a4 8fa60040 
	02403821 0411FF0E 00000000 10000029 26100001 afb20014 afb10018 afb2001c 
	afb10020 afb20024 afb50028 8fa400a0 8fa500a4 8fa6003c 02403821 0411FE56 
	00000000 1000001b 26100001 5637000c afb30010 afb40010 afb20014 afb50018 
	8fa400a8 8fa500ac 8fa60040 02403821 0411FEF3 00000000 1000000e 26100001 
	afb20014 afb10018 afb2001c afb10020 afb20024 afb50028 8fa400a8 8fa500ac 
	8fa6003c 02403821 0411FE3B 00000000 26100001 02719821 161effc4 26940001 
	8fa50044 8fa20054 00a22821 afa50044 8fa30040 2463ffff afa30040 26d60001 
	8fa50038 52c50078 02208021 8fa20044 afa2003c 8fb4004c 02809821 1000ffb3 
	02408021 24020001 8fa30050 14620071 24020002 8fa50058 00052823 afa50048 
	8fa3005c 24620001 8fa50058 00451023 afa20044 2462fffa afa20054 afa30040 
	00009021 8fa5004c 00b01823 24630001 001010c0 00501023 00621023 afa20064 
	27a20030 8fa3005c 00431023 afa20068 02008821 10000048 0280f021 92a20005 
	02021007 30420001 1040001c 00000000 5637000c afb30010 afb40010 afb20014 
	afbe0018 8fa400a0 8fa500a4 8fa60040 02403821 0411FEA2 00000000 10000029 
	2610ffff afb20014 afb10018 afb2001c afb10020 afb20024 afbe0028 8fa400a0 
	8fa500a4 8fa6003c 02403821 0411FDEA 00000000 1000001b 2610ffff 5637000c 
	afb30010 afb40010 afb20014 afbe0018 8fa400a8 8fa500ac 8fa60040 02403821 
	0411FE87 00000000 1000000e 2610ffff afb20014 afb10018 afb2001c afb10020 
	afb20024 afbe0028 8fa400a8 8fa500ac 8fa6003c 02403821 0411FDCF 00000000 
	2610ffff 02719821 1616ffc4 26940001 8fa50044 8fa20048 00a22821 afa50044 
	8fa30040 2463ffff afa30040 8fa50054 50650073 02208021 8fa20044 afa2003c 
	8fb30064 8fa3004c 2474fff9 24100007 8fa50068 8fa20040 00a2a821 24170001 
	1000ffae 2416ffff 02a0a021 24020002 8fa30050 14620064 24020003 8fa50058 
	00052823 afa50050 8fa3005c 24620001 8fa50058 00451023 afa20044 afa00040 
	24160001 00009021 27be002f 02008821 1000004b 0280b821 92020000 02a21024 
	1040001c 00000000 5636000c afb30010 afb40010 afb20014 afb70018 8fa400a0 
	8fa500a4 8fa60048 02403821 0411FE3C 00000000 10000029 2610ffff afb20014 
	afb10018 afb2001c afb10020 afb20024 afb70028 8fa400a0 8fa500a4 8fa6003c 
	02403821 0411FD84 00000000 1000001b 2610ffff 5636000c afb30010 afb40010 
	afb20014 afb70018 8fa400a8 8fa500ac 8fa60048 02403821 0411FE21 00000000 
	1000000e 2610ffff afb20014 afb10018 afb2001c afb10020 afb20024 afb70028 
	8fa400a8 8fa500ac 8fa6003c 02403821 0411FD69 00000000 2610ffff 02719821 
	161effc5 26940001 8fa20040 24420001 afa20040 8fa30044 8fa50050 00651821 
	afa30044 8fa20048 2442ffff afa20048 8fa30040 24050008 1065007c 8fbf0094 
	8fa20040 0056a804 8fa30044 afa3003c 27b00035 8fb4004c 1000ffaf 02809821 
	03c0a021 24020003 8fa50050 14a2006e 8fa50058 8fa20060 24440001 00051840 
	000510c0 00431823 00831823 afa30050 00051823 afa30054 00451023 8fa5005c 
	00a21021 afa20048 24a20007 afa20044 24030007 afa30040 24170001 00009021 
	27a50036 afa50038 1000004d 0280f021 92220000 02c21024 1040001c 00000000 
	5617000c afb40010 afb50010 afb20014 afbe0018 8fa400a0 8fa500a4 8fa60044 
	02403821 0411FDCE 00000000 10000029 26310001 afb20014 afb00018 afb2001c 
	afb00020 afb20024 afbe0028 8fa400a0 8fa500a4 8fa6003c 02403821 0411FD16 
	00000000 1000001b 26310001 5617000c afb30010 afb50010 afb20014 afbe0018 
	8fa400a8 8fa500ac 8fa60044 02403821 0411FDB3 00000000 1000000e 26310001 
	afb20014 afb00018 afb2001c afb00020 afb20024 afbe0028 8fa400a8 8fa500ac 
	8fa6003c 02403821 0411FCFB 00000000 26310001 0290a021 26b50001 8fa20038 
	1622ffc3 02709821 8fa30040 2463ffff afa30040 8fa50048 8fa20054 00a22821 
	afa50048 8fa30044 2463ffff afa30044 8fa50040 2402ffff 10a2000c 8fbf0094 
	8fa30040 0077b004 8fa50048 afa5003c 27b10030 8fa2004c 2455fffb 8fb30050 
	1000ffab 0260a021 8fbf0094 8fbe0090 8fb7008c 8fb60088 8fb50084 8fb40080 
	8fb3007c 8fb20078 8fb10074 8fb00070 03e00008 27bd0098 

'nextchar
14e00008 24020001 
	00061040 000618c0 00621023 8c830000 00621021 10000012 ac820000 14e20007 
	00061040 000630c0 00463023 8c820000 00463021 03e00008 ac860000 24020002 
	14e20007 00061040 000630c0 00c23023 8ca20000 00463021 03e00008 aca60000 
	24020003 14e20006 00061040 000630c0 00463023 8ca20000 00463021 aca60000 
	03e00008 00000000 

'pstring
27bdff78 afbf0084 afbe0080 afb7007c afb60078 afb50074 
	afb40070 afb3006c afb20068 afb10064 afb00060 8fa30098 8fb000a0 8fa200a8 
	afa20048 8fa700b0 8fa800b8 8fb500c0 8fb400c4 afa60040 afa30044 02009021 
	00409821 00e0b021 afa40058 92820000 1040003f 0100b821 1840005a 24100001 
	00071fc3 afa30048 000817c3 afa2004c 00121fc3 afa30050 001317c3 afa20054 
	02901021 90420000 2443ffe0 306300ff 2c630060 50600008 00002021 2442ffe0 
	000210c0 8fa30058 00431021 8c440000 10000002 8c450004 00002821 afb70010 
	8fa2004c afa20014 8fa20040 afa20018 000217c3 afa2001c 8fa20044 afa20020 
	000217c3 afa20024 afb20028 8fa30050 afa3002c afb30030 8fa20054 afa20034 
	afb50038 02c03021 8fa70048 0411FDBF 00000000 00408821 0060f021 27a40040 
	27a50044 02403021 02603821 0411FF8A 00000000 26100001 92820000 0050102a 
	5040ffd0 02901021 1000001f 8fa20040 afa80010 000847c3 afa80014 afa60018 
	000637c3 afa6001c afa30020 00031fc3 afa30024 afb00028 001017c3 afa2002c 
	8fa30048 afa30030 000317c3 afa20034 afb50038 00e03021 00073fc3 0411FD9B 
	00000000 00408821 0060f021 27a40040 27a50044 02003021 8fa70048 0411FF66 
	00000000 8fa20040 aea20020 000217c3 aea20024 8fa20044 aea20028 000217c3 
	aea2002c 02201021 03c01821 8fbf0084 8fbe0080 8fb7007c 8fb60078 8fb50074 
	8fb40070 8fb3006c 8fb20068 8fb10064 8fb00060 03e00008 27bd0088 

'dcirch
27bdffa0 
	afbf005c afbe0058 afb70054 afb60050 afb5004c afb40048 afb30044 afb20040 
	afb1003c afb00038 afa40060 afa50064 00c0b021 8fb50070 8fb00078 8fa20080 
	8fb70088 afa60024 afb50028 afa20020 30420010 1040002a 02008821 000697c3 
	02151021 afa20010 000217c3 afa20014 afb70018 02403821 0411FCA9 00000000 
	02b01023 afa20010 000217c3 afa20014 afb70018 8fa40060 8fa50064 02c03021 
	02403821 0411FC9E 00000000 001597c3 02163821 afb50010 afb20014 afb70018 
	8fa40060 8fa50064 00e03021 00073fc3 0411FC93 00000000 02d03823 afb50010 
	afb20014 afb70018 8fa40060 8fa50064 00e03021 00073fc3 0411FC89 00000000 
	1a20008f 24110001 02308823 0010f023 001ef040 26b3ffff 26d4ffff 26b50001 
	26d60001 00009021 8fa20020 30420004 afa2002c 8fa30020 30630002 afa30030 
	8fa20020 30420008 afa20034 8fa30020 30630001 afa30020 06200004 8fa2002c 
	2610ffff 27de0002 023e8821 10400019 26520001 8fa30028 02031021 afa20010 
	000217c3 afa20014 afb70018 8fa40060 8fa50064 02c03021 00163fc3 0411FC60 
	00000000 8fa20024 02023821 afb50010 001517c3 afa20014 afb70018 8fa40060 
	8fa50064 00e03021 00073fc3 0411FC54 00000000 8fa30030 1060001a 8fa30034 
	8fa30028 00701023 afa20010 000217c3 afa20014 afb70018 8fa40060 8fa50064 
	02c03021 00163fc3 0411FC45 00000000 8fa20024 02023821 afb30010 001317c3 
	afa20014 afb70018 8fa40060 8fa50064 00e03021 00073fc3 0411FC39 00000000 
	8fa30034 1060001a 8fa20020 8fa20024 00503823 afb50010 001517c3 afa20014 
	afb70018 8fa40060 8fa50064 00e03021 00073fc3 0411FC2A 00000000 8fa30028 
	02031021 afa20010 000217c3 afa20014 afb70018 8fa40060 8fa50064 02803021 
	00143fc3 0411FC1E 00000000 8fa20020 5040001a 2673ffff 8fa30024 00703823 
	afb30010 001317c3 afa20014 afb70018 8fa40060 8fa50064 00e03021 00073fc3 
	0411FC0F 00000000 8fa30028 00701023 afa20010 000217c3 afa20014 afb70018 
	8fa40060 8fa50064 02803021 00143fc3 0411FC03 00000000 2673ffff 2694ffff 
	26b50001 0250102a 10400005 26d60001 00121040 24420001 1000ff87 02228821 
	8fbf005c 8fbe0058 8fb70054 8fb60050 8fb5004c 8fb40048 8fb30044 8fb20040 
	8fb1003c 8fb00038 03e00008 27bd0060 

'fcirch
27bdff90 afbf006c afbe0068 afb70064 
	afb60060 afb5005c afb40058 afb30054 afb20050 afb1004c afb00048 8fb10080 
	8fb40090 8fbe00a0 afa40038 afa6003c 8fa20088 1a200076 02801821 24100001 
	02118023 0011b823 0017b840 2495ffff 24d3ffff 26940003 24960001 00009021 
	30440001 afa40030 24630001 afa30040 30420002 afa20034 06000004 8fa20030 
	2631ffff 26f70002 02178021 1040002a 26520001 8fa3003c 00711023 afa20010 
	000217c3 afa20014 24020001 00001821 afa20018 afa3001c 00111040 8fa30040 
	00621021 afa20020 000217c3 afa20024 afbe0028 8fa40098 8fa5009c 02c03021 
	00163fc3 0411FB04 00000000 8fa40038 02243821 afb30010 001317c3 afa20014 
	24020001 00001821 afa20018 afa3001c afb40020 001417c3 afa20024 afbe0028 
	8fa40098 8fa5009c 00e03021 00073fc3 0411FAF1 00000000 8fa30034 5060002b 
	26b5ffff 8fa4003c 00911023 afa20010 000217c3 afa20014 24020001 00001821 
	afa20018 afa3001c 00111040 8fa30040 00621021 afa20020 000217c3 afa20024 
	afbe0028 8fa40098 8fa5009c 02a03021 00153fc3 0411FAD8 00000000 8fa40038 
	00913823 afb30010 001317c3 afa20014 24020001 00001821 afa20018 afa3001c 
	afb40020 001417c3 afa20024 afbe0028 8fa40098 8fa5009c 00e03021 00073fc3 
	0411FAC5 00000000 26b5ffff 2673ffff 26940002 0251102a 10400005 26d60001 
	00121040 24420001 1000ff9b 02028021 8fbf006c 8fbe0068 8fb70064 8fb60060 
	8fb5005c 8fb40058 8fb30054 8fb20050 8fb1004c 8fb00048 03e00008 27bd0070 

'ftri
	27bdff88 afbf0074 afb70070 afb6006c afb50068 afb40064 afb30060 afb2005c 
	afb10058 afb00054 8fa20090 8fb400a8 8fb500ac 8fb100b0 afa40038 afa6003c 
	8fa30088 afa30040 afa20044 8fa30098 afa30048 8fa300a0 0046102a 10400009 
	afa3004c 27a4003c 27a50044 0411FB70 00000000 27a40038 27a50040 0411FB6C 
	00000000 8fa2004c 8fa30044 0043102a 1040000a 8fa20044 27a4004c 27a50044 
	0411FB63 00000000 27a40048 27a50040 0411FB5F 00000000 8fa20044 8fa3003c 
	0043102a 1040000a 8fb0003c 27a4003c 27a50044 0411FB56 00000000 27a40038 
	27a50040 0411FB52 00000000 8fb0003c 8fa2004c 1602002e 8fb20044 8fa20038 
	afa20030 afa20034 8fa30040 0062202a 10800003 0043102a 10000003 afa30030 
	54400001 afa30034 8fa20048 8fa30030 0043182a 10600003 8fa30034 10000004 
	afa20030 0062182a 54600001 afa20034 8fa70030 8fa2003c afa20010 000217c3 
	afa20014 24020001 00001821 afa20018 afa3001c 8fa20034 24420001 00471023 
	afa20020 000217c3 afa20024 afb10028 02802021 02a02821 00e03021 00073fc3 
	0411FA45 00000000 1000007a 8fbf0074 

'.LBB2
00521026 0002102b 02429023 0250102a 
	14400039 8fa2004c 24160001 0000b821 8fa20038 8fa3003c 02032823 8fa60040 
	00c23023 70a63002 8fa40044 00832023 00c4001a 008001f4 00002012 00822021 
	afa40030 8fa60048 00c23023 70a62802 8fa6004c 00c31823 00a3001a 006001f4 
	00001812 00621021 afa20034 0044102a 10400006 8fa70030 27a40030 27a50034 
	0411FAFB 00000000 8fa70030 afb00010 001017c3 afa20014 8fa20034 24420001 
	00471023 afa20018 000217c3 afa2001c afb60020 afb70024 afb10028 02802021 
	02a02821 00e03021 00073fc3 0411FA0A 00000000 26100001 0250102a 1040ffcd 
	8fa20038 8fa2004c 0050182a 14600038 24120001 00009821 8fa60040 8fa40038 
	8fa50048 8fa80044 02083823 00a61823 70e33802 00484023 00e8001a 010001f4 
	00001812 00661821 afa30030 8fa7003c 02073023 00a42823 70c53002 00471023 
	00c2001a 004001f4 00001012 00442021 afa40034 0083202a 10800006 8fa70030 
	27a40030 27a50034 0411FAC1 00000000 8fa70030 afb00010 001017c3 afa20014 
	8fa20034 24420001 00471023 afa20018 000217c3 afa2001c afb20020 afb30024 
	afb10028 02802021 02a02821 00e03021 00073fc3 0411F9D0 00000000 26100001 
	8fa2004c 0050182a 1060ffcc 8fa60040 

'.LBE2
8fbf0074 8fb70070 8fb6006c 8fb50068 
	8fb40064 8fb30060 8fb2005c 8fb10058 8fb00054 03e00008 27bd0078 

'main
27bdffb8 
	afbf0044 afb00040 00808021 00e01021 8faa0058 8fa9005c 8fa80060 8fac0064 
	8c830000 8c840004 00643825 14e00010 8fab0068 8ca50000 8cc70000 8c420000 
	afa20010 000217c3 afa20014 afaa0018 00a02021 00052fc3 00e03021 00073fc3 
	0411FA4F 00000000 100000c6 8fbf0044 24070001 14670018 24070002 14800016 
	00000000 8ca40000 8ca50004 8cc70004 8cc60000 8c430004 8c420000 afa20010 
	afa30014 8d420000 8d430004 afa20018 afa3001c 8d220000 8d230004 afa20020 
	afa30024 afa80028 0411F98B 00000000 100000ac 8fbf0044 14670021 24070003 
	1480001f 00000000 8ca40000 8ca50004 8cc70004 8cc60000 8c430004 8c420000 
	afa20010 afa30014 8d420000 8d430004 afa20018 afa3001c 8d220000 8d230004 
	afa20020 afa30024 8d020000 8d030004 afa20028 afa3002c 8d820000 8d830004 
	afa20030 afa30034 afab0038 0411FEBC 00000000 8e020000 10000089 8e030004 
	14670019 24070004 14800017 00000000 8ca40000 8ca50004 8cc70004 8cc60000 
	8c420000 afa20010 000217c3 afa20014 8d420000 afa20018 000217c3 afa2001c 
	8d220000 afa20020 000217c3 afa20024 afa80028 0411FA33 00000000 8e020000 
	1000006f 8e030004 14670009 24070005 14800007 00000000 8ca40000 0411F8EF 
	00000000 8e020000 10000065 8e030004 14670009 24070007 14800007 00000000 
	8ca40000 0411F8ED 00000000 8e020000 1000005b 8e030004 14670022 24070008 
	14800020 00000000 8ca40000 8ca50004 8cc70004 8cc60000 8c430004 8c420000 
	afa20010 afa30014 8d420000 8d430004 afa20018 afa3001c 8d220000 8d230004 
	afa20020 afa30024 8d020000 8d030004 afa20028 afa3002c 8d820000 8d830004 
	afa20030 afa30034 afab0038 8fa2006c afa2003c 0411FC6C 00000000 10000039 
	8fbf0044 1467001d 24070009 1480001b 00000000 8ca40000 8ca50004 8cc70004 
	8cc60000 8c430004 8c420000 afa20010 afa30014 8d420000 8d430004 afa20018 
	afa3001c 8d220000 8d230004 afa20020 afa30024 8d020000 8d030004 afa20028 
	afa3002c afac0030 0411FDB9 00000000 8e020000 1000001a 8e030004 14670019 
	8fbf0044 54800018 8fb00040 8ca40000 8ca50004 8cc70004 8cc60000 8c430004 
	8c420000 afa20010 afa30014 8d420000 8d430004 afa20018 afa3001c 8d220000 
	8d230004 afa20020 afa30024 afa80028 0411FCC2 00000000 8e020000 8e030004 
	8fbf0044 8fb00040 03e00008 27bd0048 
End CFunction

CFunction font
	00000000
	00000000 00000000 5f000000 00000000 00070000 00000007 147f1400 0000147f 
	7f2a1200 0000242a 08646200 00002313 56205000 00003649 07030000 00000008 
	22410000 0000001c 221c0000 00000041 7f1c2a00 00002a1c 3e080800 00000808 
	70300000 00000080 08080800 00000808 60600000 00000000 08040200 00002010 
	49453e00 00003e51 7f400000 00000042 49494600 00007249 494d3300 00002141 
	127f1000 00001814 45453900 00002745 49493100 00003c4a 11090700 00004121 
	49493600 00003649 49291e00 00004649 14000000 00000000 34000000 00000040 
	14224100 00000008 14141400 00001414 22140800 00000041 59090600 00000201 
	5d594e00 00003e41 11127c00 00007c12 49493600 00007f49 41412200 00003e41 
	41413e00 00007f41 49494100 00007f49 09090100 00007f09 41517300 00003e41 
	08087f00 00007f08 7f410000 00000041 413f0100 00002040 14224100 00007f08 
	40404000 00007f40 1c027f00 00007f02 08107f00 00007f04 41413e00 00003e41 
	09090600 00007f09 51215e00 00003e41 19294600 00007f09 49493200 00002649 
	7f010300 00000301 40403f00 00003f40 40201f00 00001f20 38403f00 00003f40 
	08146300 00006314 78040300 00000304 494d4300 00006159 41414100 0000007f 
	08102000 00000204 41417f00 00000041 01020400 00000402 40404000 00004040 
	07080000 00000003 54784000 00002054 44443800 00007f28 44442800 00003844 
	44287f00 00003844 54541800 00003854 7e090200 00000008 a49c7800 000018a4 
	04047800 00007f08 7d400000 00000044 403d0000 00002040 28440000 00007f10 
	7f400000 00000041 78047800 00007c04 04047800 00007c08 44443800 00003844 
	24241800 0000fc18 2418fc00 00001824 04040800 00007c08 54542400 00004854 
	3f442400 00000404 40207c00 00003c40 40201c00 00001c20 30403c00 00003c40 
	10284400 00004428 90907c00 00004c90 544c4400 00004464 36410000 00000008 
	77000000 00000000 36080000 00000041 02040200 00000201 23263c00 00003c26 
End CFunction
'
sub T24_initialise
  T24.initdisplay
  print "Controller type :", hex$(T24.rreg(0), 4)
end sub
'
sub T24_test
  local integer i, xfs, yfs, x0, y0, x1, y1, wi, ht, sz
  local float tn
  T24.setrot(0)
  wi= T24_params(0)
  ht= T24_params(1)
  T24.fillscreen(black)
  T24.drect(0, 0, wi, ht, red)
  T24.pbitmap(114, 10, -1, 2, 0, magenta, black)
  T24.pstring(40, 40, "Welcome to the", 2, 0, green, black)
  T24.pstring(5, 70, "Micromite MK2", 3, 0, red, black)
  T24.pstring(60, 120, "in colour", 2, 0, yellow, black)
  T24.pstring(60, 170,  "ST7781 controller", 1, 0, cyan, black)
  pause 2000
' demo fast line draw
  T24.setrot(T24_normal)
  T24.fillscreen(black)
  x0=0:y0=0:y1=ht-1
  for i=0 to 44 step 2
    tn=tan(rad(i))
    x1=wi*tn
    T24.dline(x0, y0, x1, y1, red)
  next i
  x1=wi-1
  for i=0 to 44 step 2
    tn=tan(rad(i))
    y1=ht*tn
    T24.dline(x0, y0, x1, y1, red)
  next i
  T24.drect(0, 00, wi, ht, blue)
  pause 2000
  T24.fillscreen(black)
'demo fast text write
  T24.setrot(T24_rt_right)
  for i=0 to wi-8 step 8
    T24.pstring(0, i, "Hello world:Bye world:Hello world:Bye world:Hello world:Bye world", 1, T24_normal, green, black)
  next i
  T24.setrot(T24_normal)
  pause 2000
  T24.fillscreen(black)
  for i=ht-1 to 15 step -16
    T24.pstring(wi-1, i, "Micromite MK2:Micromite MK2", 2, T24_inverse, red, black)
  next i
  pause 2000
  T24.fillscreen(black)
  for i=24 to wi step 24
    T24.pstring(i, 0, "Rotate right:Rotate right", 3, T24_rt_right, yellow, black)
  next i
  pause 2000
  T24.fillscreen(black)
  for i=wi-32 to 0 step -32
    T24.pstring(i, ht-1, "Rotate Left:Rotate Left", 4, T24_rt_left, blue, black)
  next i
  pause 2000
  T24.fillscreen(black)
  ' test drawing rectangles
  for i=0 to 3
     T24.setrot(i)
     T24.frect(5, 5, 30, 45, blue)
     T24.drect(2, 2, 36, 51, red)
  next i
  pause 2000
' test drawing rounded rectangles
  T24.fillscreen(black)
  for i=0 to 3
     T24.setrot(i)
     T24.frndrect(5, 5, 30, 45, 10, blue)
     T24.drndrect(2, 2, 36, 51, 12, red)
  next i
  pause 2000
  T24.fillscreen(black)
' test drawing circles
  for i=0 to 3
     T24.setrot(i)
     T24.fcirc(40, 40, 37, blue)
     T24.dcirc(40, 40, 39, red)
  next i
  pause 2000
' test drawing triangles and line drawing
  T24.fillscreen(black)
  for i=0 to 3
     T24.setrot(i)
     T24.ftri(4, 4, 40, 6, 22, 24, blue)
     T24.dtri(1, 2, 44, 4, 22, 27, red)
  next i
  pause 2000
' test character output and string output at all orientations
  for sz=1 to 3
  T24.fillscreen(black)
  T24.setrot(T24_normal)
  T24.pstring(wi/2, ht/2, "N", 3, T24_normal, white, black)
  T24.pstring(0, 0, "T24_normal", sz, T24_normal, red, black)
  T24.pstring(wi-1, ht-1, "Inverted", sz, T24_inverse, blue, black)
  T24.pstring(wi-1, 0, "Rotated right", sz, T24_rt_right, green, black)
  T24.pstring(0, ht-1, "Rotated left", sz, T24_rt_left, yellow, black)
  pause 1000
  T24.fillscreen(black)
  T24.setrot(T24_inverse)
  T24.pstring(wi/2, ht/2, "I", 3, T24_inverse, white, black)
  T24.pstring(0, 0, "T24_normal", sz, T24_normal, red, black)
  T24.pstring(wi-1, ht-1, "Inverted", sz, T24_inverse, blue, black)
  T24.pstring(wi-1, 0, "Rotated right", sz, T24_rt_right, green, black)
  T24.pstring(0, ht-1, "Rotated left", sz, T24_rt_left, yellow, black)
  pause 1000
  T24.fillscreen(black)
  T24.setrot(T24_rt_right)
  T24.pstring(ht/2, wi/2, "R", 3, T24_rt_left, white, black)
  T24.pstring(0, 0, "T24_normal", sz, T24_normal, red, black)
  T24.pstring(ht-1, wi-1, "Inverted", sz, T24_inverse, blue, black)
  T24.pstring(ht-1, 0, "Rotated right", sz, T24_rt_right, green, black)
  T24.pstring(0, wi-1, "Rotated left", sz, T24_rt_left, yellow, black)
  pause 1000
  T24.fillscreen(black)
  T24.setrot(T24_rt_left)
  T24.pstring(ht/2, wi/2, "L", 3, T24_rt_right, white, black)
  T24.pstring(0, 0, "T24_normal", sz, T24_normal, red, black)
  T24.pstring(ht-1, wi-1, "Inverted", sz, T24_inverse, blue, black)
  T24.pstring(ht-1, 0, "Rotated right", sz, T24_rt_right, green, black)
  T24.pstring(0, wi-1, "Rotated left", sz, T24_rt_left, yellow, black)
  pause 1000
  next sz
end SUB
